using HermesSocketLibrary.Requests.Messages;

namespace TwitchChatTTS.Twitch.Redemptions
{
    public interface IRedemptionManager
    {
        void Add(RedeemableAction action);
        void Add(Redemption redemption);
        Task Execute(RedeemableAction action, string senderDisplayName, long senderId);
        IEnumerable<RedeemableAction> Get(string twitchRedemptionId);
        void Initialize();
        bool RemoveAction(string actionName);
        bool RemoveRedemption(string redemptionId);
        bool Update(Redemption redemption);
        bool Update(RedeemableAction action);
    }
}